package oop6_dat6_u;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;

/**
 *
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 */
public class SolidFileIO
{

    private static int number;

    public static IMyObject[] readSolids(String fileName)
    {
        ArrayList<IMyObject> list = new ArrayList<IMyObject>();
        int s1, s2, s3, sTemp;

        try {
            FileReader aFileReader = new FileReader(fileName);
            BufferedReader aBufferedReader = new BufferedReader(aFileReader);

            String line = aBufferedReader.readLine();
            StringTokenizer sT;
            while (line != null) { // while not EOF
                sT = new StringTokenizer(line, ": ");
                String s0 = sT.nextToken();

                // Cube
                if (s0.equals("C")) {
                    s1 = Integer.parseInt(sT.nextToken());
                    s2 = Integer.parseInt(sT.nextToken());
                    s3 = Integer.parseInt(sT.nextToken());
                    //aufsteigend sortieren s1, s2, s3
                    if (s1 > s2) {
                        sTemp = s1;
                        s1 = s2;
                        s2 = sTemp;
                    }
                    if (s1 > s3) {
                        sTemp = s1;
                        s1 = s3;
                        s3 = sTemp;
                    }
                    if (s2 > s3) {
                        sTemp = s2;
                        s2 = s3;
                        s3 = sTemp;
                    }
                    list.add(new Cube(number, s1, s2, s3));
                    number ++;
                }

                // Kugel - Sphere
                if (s0.equals("S")) {
                    s1 = Integer.parseInt(sT.nextToken());
                    list.add(new Sphere(number, s1));
                    number ++;
                }

                // Zylinder - Cylinder
                if (s0.equals("Y")) {
                    s1 = Integer.parseInt(sT.nextToken());
                    s2 = Integer.parseInt(sT.nextToken());

                    //aufsteigend sortieren s1, s2
                    if (s1 > s2) {
                        sTemp = s1;
                        s1 = s2;
                        s2 = sTemp;
                    }
                    list.add(new Cylinder(number, s1, s2));
                    number ++;
                }

                line = aBufferedReader.readLine();
            }
            aFileReader.close();

        } catch (FileNotFoundException ex) {
            System.out.println("ERROR:");
            ex.printStackTrace();
        } catch (IOException ex) {
            System.out.println("ERROR:");
            ex.printStackTrace();
        } catch (Exception ex) {
            System.out.println("ERROR:");
            ex.printStackTrace();
        } finally {
            return list.toArray(new IMyObject[1]); // siehe auch API-Dokumentation
        }

    }

    /**
     * mini Test
     * @param args
     */
    public static void main(String[] args)
    {
        SolidFileIO a = new SolidFileIO();
        IMyObject[] c = a.readSolids("soliddata.txt");
        for (IMyObject myObject : c) {
            System.out.println(myObject.toString());
        }

    }
}
